
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Support_ticket_messagesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const support_ticket_messages = await db.support_ticket_messages.create(
            {
                id: data.id || undefined,
        
        message: data.message
        ||
        null
            ,
            
        sent_at: data.sent_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await support_ticket_messages.setSupport_ticket( data.support_ticket || null, {
            transaction,
        });
        
        await support_ticket_messages.setAuthor_user( data.author_user || null, {
            transaction,
        });
        
        await support_ticket_messages.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.support_ticket_messages.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: support_ticket_messages.id,
            },
            data.attachments,
            options,
        );
        

        return support_ticket_messages;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const support_ticket_messagesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                message: item.message
            ||
            null
            ,
            
                sent_at: item.sent_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const support_ticket_messages = await db.support_ticket_messages.bulkCreate(support_ticket_messagesData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < support_ticket_messages.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.support_ticket_messages.getTableName(),
                    belongsToColumn: 'attachments',
                    belongsToId: support_ticket_messages[i].id,
                },
                data[i].attachments,
                options,
            );
        }
        

        return support_ticket_messages;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const support_ticket_messages = await db.support_ticket_messages.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.message !== undefined) updatePayload.message = data.message;
        
        
        if (data.sent_at !== undefined) updatePayload.sent_at = data.sent_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await support_ticket_messages.update(updatePayload, {transaction});

        
        
        if (data.support_ticket !== undefined) {
            await support_ticket_messages.setSupport_ticket(
              
              data.support_ticket,
              
              { transaction }
            );
        }
        
        if (data.author_user !== undefined) {
            await support_ticket_messages.setAuthor_user(
              
              data.author_user,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await support_ticket_messages.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.support_ticket_messages.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: support_ticket_messages.id,
            },
            data.attachments,
            options,
        );
        

        return support_ticket_messages;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const support_ticket_messages = await db.support_ticket_messages.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of support_ticket_messages) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of support_ticket_messages) {
                await record.destroy({transaction});
            }
        });


        return support_ticket_messages;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const support_ticket_messages = await db.support_ticket_messages.findByPk(id, options);

        await support_ticket_messages.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await support_ticket_messages.destroy({
            transaction
        });

        return support_ticket_messages;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const support_ticket_messages = await db.support_ticket_messages.findOne(
            { where },
            { transaction },
        );

        if (!support_ticket_messages) {
            return support_ticket_messages;
        }

        const output = support_ticket_messages.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.support_ticket = await support_ticket_messages.getSupport_ticket({
            transaction
        });
        
        
        output.author_user = await support_ticket_messages.getAuthor_user({
            transaction
        });
        
        
        output.attachments = await support_ticket_messages.getAttachments({
            transaction
        });
        
        
        output.organizations = await support_ticket_messages.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.support_tickets,
        as: 'support_ticket',
        
        where: filter.support_ticket ? {
          [Op.or]: [
            { id: { [Op.in]: filter.support_ticket.split('|').map(term => Utils.uuid(term)) } },
            {
              subject: {
                [Op.or]: filter.support_ticket.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'author_user',
        
        where: filter.author_user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.author_user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.author_user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'attachments',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.message) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'support_ticket_messages',
                        'message',
                        filter.message,
                    ),
                };
            }
            

            
            

            
            if (filter.sent_atRange) {
                const [start, end] = filter.sent_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sent_at: {
                    ...where.sent_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sent_at: {
                    ...where.sent_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.support_ticket_messages.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'support_ticket_messages',
                        'message',
                        query,
                    ),
                ],
            };
        }

        const records = await db.support_ticket_messages.findAll({
            attributes: [ 'id', 'message' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['message', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.message,
        }));
    }

    
};

